(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('battleship-performance', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['battleship-performance'] = {}, global.ng.core, global.rxjs, global.rxjs.operators));
}(this, (function (exports, i0, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var Battleship_performanceError = /** @class */ (function (_super) {
        __extends(Battleship_performanceError, _super);
        function Battleship_performanceError(message) {
            var _this = _super.call(this, message) || this;
            _this.name = "Battleship_performanceError";
            return _this;
        }
        return Battleship_performanceError;
    }(Error));

    var ShotClass = /** @class */ (function () {
        function ShotClass(oppShips) {
            this._shots = [];
            this._oppShips = oppShips;
            this._shotOpti = new Map();
        }
        Object.defineProperty(ShotClass.prototype, "shots", {
            get: function () {
                return this._shots;
            },
            enumerable: false,
            configurable: true
        });
        ShotClass.prototype.shotBefore = function (x) {
            return this._shotOpti.has(x);
        };
        ShotClass.prototype.shoot = function (x, s) {
            var e_1, _a, e_2, _b;
            if (this.shotBefore(x)) {
                return false;
            }
            try {
                for (var _c = __values(this._oppShips.shipman.ships), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var j = _d.value;
                    try {
                        for (var _e = (e_2 = void 0, __values(j.pos)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var i = _f.value;
                            if (x === i) {
                                var tmp = Object.assign({}, s.value);
                                tmp[j.length] = tmp[j.length] - 1;
                                s.next(tmp); //to update the score
                                this._shots.push({ hit: true, pos: i, shipLen: j.length });
                                this._shotOpti.set(i, i);
                                return true;
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_1) throw e_1.error; }
            }
            this._shots.push({ hit: false, pos: x });
            this._shotOpti.set(x, x);
            return true;
        };
        return ShotClass;
    }());

    var randomNum = function (x) { return Math.floor(Math.random() * x) + 1; };

    var PlayerShotClass = /** @class */ (function (_super) {
        __extends(PlayerShotClass, _super);
        function PlayerShotClass(oppShips) {
            return _super.call(this, oppShips) || this;
        }
        PlayerShotClass.prototype.shoot = function (x, scoreBoard) {
            x = x = randomNum(this._oppShips.gridSize * this._oppShips.gridSize);
            while (!_super.prototype.shoot.call(this, x, scoreBoard))
                x = randomNum(this._oppShips.gridSize * this._oppShips.gridSize);
            return true;
        };
        return PlayerShotClass;
    }(ShotClass));

    var ShipClass = /** @class */ (function () {
        function ShipClass(shipman, gridSize, shipsNo) {
            //need to set shipsNo and gridSize here  also need to set getters and setters
            this._shipman = shipman;
            this._gridSize = gridSize;
            this._shipsNo = shipsNo;
        }
        ShipClass.prototype.shipBefore = function (x) {
            return this._shipman.allPos.has(x);
        };
        Object.defineProperty(ShipClass.prototype, "gridSize", {
            get: function () {
                return this._gridSize;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(ShipClass.prototype, "shipsNo", {
            get: function () {
                return this._shipsNo;
            },
            enumerable: false,
            configurable: true
        });
        ShipClass.prototype.add = function (curr) {
            if (this._shipman.ships.length === 0) {
                var pos = [];
                pos.push(curr);
                this._shipman.allPos.set(curr, curr);
                this._shipman.ships.push({ pos: pos, length: this._shipsNo, posibleDirection: "all" /* all */ });
            }
            else {
                if (this._shipman.ships[this._shipman.ships.length - 1].pos.length < this._shipsNo - this._shipman.ships.length + 1) {
                    var len = this._shipsNo - this._shipman.ships.length + 1;
                    var d = this.checkValidity(curr, len, this._shipman.ships[this._shipman.ships.length - 1]);
                    if (d !== "no" /* no */) {
                        this._shipman.allPos.set(curr, curr);
                        this._shipman.ships[this._shipman.ships.length - 1].length = len;
                        this._shipman.ships[this._shipman.ships.length - 1].pos.push(curr);
                        this._shipman.ships[this._shipman.ships.length - 1].posibleDirection = d;
                    }
                }
                else {
                    //first time working on a new ship
                    var len = this._shipsNo - this._shipman.ships.length;
                    var d = this.checkValidity(curr, len);
                    if (d !== "no" /* no */) {
                        this._shipman.allPos.set(curr, curr);
                        this._shipman.ships.push({ pos: [curr], length: len, posibleDirection: d });
                    }
                }
            }
            return this;
        };
        ShipClass.prototype.checkValidity = function (curr, len, ship) {
            var e_1, _a;
            if (this.shipBefore(curr))
                return "no" /* no */;
            if (ship === undefined) {
                if (this.verticalCan(curr, len) && this.horizontalCan(curr, len))
                    return "all" /* all */;
                else if (this.verticalCan(curr, len))
                    return "vertical" /* vertical */;
                else if (this.horizontalCan(curr, len))
                    return "horizontal" /* horizontal */;
                else
                    return "no" /* no */;
            }
            else {
                try {
                    for (var _b = __values(ship.pos), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var i = _c.value;
                        if (Math.abs(curr - i) === this._gridSize && (ship.posibleDirection === "vertical" /* vertical */ || ship.posibleDirection === "all" /* all */))
                            return "vertical" /* vertical */;
                        else if (Math.abs(curr - i) === 1 && (ship.posibleDirection === "horizontal" /* horizontal */ || ship.posibleDirection === "all" /* all */))
                            return "horizontal" /* horizontal */;
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                return "no" /* no */;
            }
        };
        //check if the the shippart can be placed vertically
        ShipClass.prototype.verticalCan = function (curr, limit) {
            limit--; //exclusive of the current so limit - 1;
            var top = 0;
            var t = curr;
            var b = curr;
            t = t - this._gridSize;
            while (t > 0) {
                if (this.shipBefore(t))
                    break;
                top++;
                if (top >= limit)
                    return true;
                t = t - this._gridSize;
            }
            var bottom = 0;
            b = b + this._gridSize;
            while (b <= this._gridSize * this._gridSize) {
                if (this.shipBefore(b))
                    break;
                bottom++;
                if (bottom >= limit)
                    return true;
                b = b + this._gridSize;
            }
            return top + bottom >= limit;
        };
        ShipClass.prototype.inHorizontalLine = function (curr, n) {
            if (curr % this._gridSize === 0)
                curr--;
            return Math.floor(curr / this._gridSize) * this._gridSize + 1 <= n && Math.floor(curr / this._gridSize) * this._gridSize + this._gridSize >= n;
        };
        ShipClass.prototype.horizontalCan = function (curr, limit) {
            limit--; //exclusive of the current so limit - 1;
            var right = 0;
            var r = curr;
            var l = curr;
            r = r + 1;
            while (this.inHorizontalLine(curr, r)) {
                if (this.shipBefore(r))
                    break;
                right++;
                if (right >= limit)
                    return true;
                r = r + 1;
            }
            var left = 0;
            l = l - 1;
            while (this.inHorizontalLine(curr, l)) {
                if (this.shipBefore(l))
                    break;
                left++;
                if (left >= limit)
                    return true;
                l = l - 1;
            }
            return left + right >= limit;
        };
        Object.defineProperty(ShipClass.prototype, "shipman", {
            get: function () {
                return this._shipman;
            },
            enumerable: false,
            configurable: true
        });
        return ShipClass;
    }());

    var ComputerClass = /** @class */ (function (_super) {
        __extends(ComputerClass, _super);
        function ComputerClass(shipman, gridSize, shipsNo) {
            return _super.call(this, shipman, gridSize, shipsNo) || this;
        }
        ComputerClass.prototype.add = function (x) {
            var d;
            var len;
            if (this._shipman.ships.length !== 0) {
                if (this._shipman.ships[this._shipman.ships.length - 1].pos.length < this.shipsNo - this._shipman.ships.length + 1) {
                    len = this.shipsNo - this._shipman.ships.length + 1;
                    d = this.checkValidity(x, len, this._shipman.ships[this._shipman.ships.length - 1]);
                }
                else {
                    len = this.shipsNo - this._shipman.ships.length;
                    d = this.checkValidity(x, len);
                }
            }
            else {
                d = "all" /* all */;
                len = this.shipsNo;
            }
            this.addMultiple(x, d, len);
            return this;
        };
        ComputerClass.prototype.addMultiple = function (x, d, len) {
            if (d === "no" /* no */)
                return;
            if (d === "all" /* all */)
                d = this.randomDirection();
            if (d === "horizontal" /* horizontal */)
                this.mulHori(x, len);
            else
                this.mulVert(x, len);
        };
        ComputerClass.prototype.mulVert = function (x, len) {
            var xUp = x - this._gridSize;
            var xDown = x + this._gridSize;
            _super.prototype.add.call(this, x);
            len--;
            var u = false;
            var d = false;
            while (len > 0) {
                if (!u)
                    u = _super.prototype.shipBefore.call(this, xUp);
                if (!d)
                    d = _super.prototype.shipBefore.call(this, xDown);
                if (xDown <= this._gridSize * this._gridSize && !d) {
                    len--;
                    _super.prototype.add.call(this, xDown);
                    xDown = xDown + this._gridSize;
                }
                if (len > 0 && xUp > 0 && !u) {
                    len--;
                    _super.prototype.add.call(this, xUp);
                    xUp = xUp - this._gridSize;
                }
            }
        };
        ComputerClass.prototype.mulHori = function (x, len) {
            var xLeft = x - 1;
            var xRight = x + 1;
            _super.prototype.add.call(this, x);
            var l = false;
            var r = false;
            len--;
            while (len > 0) {
                if (!l)
                    l = _super.prototype.shipBefore.call(this, xLeft);
                if (!r)
                    r = _super.prototype.shipBefore.call(this, xRight);
                if (_super.prototype.inHorizontalLine.call(this, x, xLeft) && !l) {
                    len--;
                    _super.prototype.add.call(this, xLeft);
                    xLeft = xLeft - 1;
                }
                if (_super.prototype.inHorizontalLine.call(this, x, xRight) && len > 0 && !r) {
                    len--;
                    _super.prototype.add.call(this, xRight);
                    xRight = xRight + 1;
                }
            }
        };
        ComputerClass.prototype.randomDirection = function () {
            return ["vertical" /* vertical */, "horizontal" /* horizontal */][Math.floor(Math.random() * 2)];
        };
        return ComputerClass;
    }(ShipClass));

    var ComputerShotClass = /** @class */ (function (_super) {
        __extends(ComputerShotClass, _super);
        function ComputerShotClass(oppShips) {
            var _this = _super.call(this, oppShips) || this;
            _this._nextTry = {};
            for (var i = 0; i < _this._oppShips.shipsNo; i++)
                _this._nextTry[i + 1] = [];
            _this._shipProcessing = [];
            return _this;
        }
        ComputerShotClass.prototype.shoot = function (x, scoreBoard) {
            var s = 0; //aka shipLen
            //check for currently processing ship
            if (this._shipProcessing.length > 0) {
                for (var i = 0; i < this._shipProcessing.length; i++) {
                    if (this._nextTry[this._shipProcessing[0]].length === this._shipProcessing[0]) { //prune out finished ships
                        this._shipProcessing.shift(); //no longer have to process that ship
                        i--;
                    }
                    else { //process that ship
                        s = this._shipProcessing[0];
                        //may require reaccessement of the vertical and horizontal viability
                        break;
                    }
                } //after pruning out all the front ships that have aalrady been finished processing
                if (s > 0) { //that means it is processing from this._shipProcessing
                    //just look at the last NextBest for that nextTry
                    var nb = this._nextTry[s][this._nextTry[s].length - 1]; //last element of the nextTry[s]
                    //check if it is still a single shot only
                    if (this._nextTry[s].length < 2)
                        this.updateSingle(s, nb.hitVal, nb);
                    for (var i = 0; i < nb.possible.length; i++) {
                        if (_super.prototype.shotBefore.call(this, nb.possible[i])) {
                            nb.possible.shift();
                            i--; //so dont process that posible val
                        }
                        else { //never shot before and in the nextBest[best case scenerio]
                            _super.prototype.shoot.call(this, nb.possible[i], scoreBoard);
                            if (this._shots[this._shots.length - 1].hit) {
                                if (this._shots[this._shots.length - 1].shipLen === s) {
                                    this.updateNextTryMultiple(s, nb.possible[i]);
                                }
                                else { //missed the nextTry boat but coinsidently hit another boat
                                    //OPTIMIZATION: check if it should go vertically or horizontally
                                    this.updateNextTry(this._shots[this._shots.length - 1].shipLen, nb.possible.shift());
                                }
                            }
                            else {
                                nb.possible.shift();
                            }
                            break;
                        }
                    }
                }
                else { //there is not more ships in queue to be processed so take randomShotAgain
                    x = x = randomNum(this._oppShips.gridSize * this._oppShips.gridSize);
                    while (!_super.prototype.shoot.call(this, x, scoreBoard))
                        x = randomNum(this._oppShips.gridSize * this._oppShips.gridSize);
                    if (this._shots[this._shots.length - 1].hit) { //this is a form of clean up
                        this.updateNextTry(this._shots[this._shots.length - 1].shipLen, x);
                    }
                }
            }
            else {
                //random number
                x = x = randomNum(this._oppShips.gridSize * this._oppShips.gridSize);
                while (!_super.prototype.shoot.call(this, x, scoreBoard))
                    x = randomNum(this._oppShips.gridSize * this._oppShips.gridSize);
                if (this._shots[this._shots.length - 1].hit) { //this is a form of clean up
                    //for the next try
                    this.updateNextTry(this._shots[this._shots.length - 1].shipLen, x);
                }
            }
            return true;
        };
        ComputerShotClass.prototype.addToShipProcessing = function (shipLen) {
            var e_1, _a;
            try {
                for (var _b = __values(this._shipProcessing), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var i = _c.value;
                    if (i === shipLen)
                        return; //dont push cuz already to be processed
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            this._shipProcessing.push(shipLen);
        };
        //x is the shot taken,
        /*These function can be in a helper file */
        ComputerShotClass.prototype.horiGaps = function (nb) {
            var r = [];
            var tmp = nb.map(function (x) { return x.hitVal; }).sort(function (a, b) { return a < b ? -1 : a > b ? 1 : 0; });
            //get all the nb.possible
            for (var i = 1; i < tmp.length; i++) {
                for (var j = 1; j < tmp[i] - tmp[i - 1]; j++) { //that means in between those two are the gap(s)
                    r.push(tmp[i - 1] + j);
                }
            }
            return r;
        };
        ComputerShotClass.prototype.horiPadding = function (nb, shipLen) {
            var r = [];
            var ht = nb.map(function (s) { return s.hitVal; }).sort(function (a, b) { return a < b ? -1 : a > b ? 1 : 0; });
            ht = [ht[0], ht[ht.length - 1]];
            var bodyLen = ht[1] - ht[0];
            var right = ht[1] + 1;
            var left = ht[0] - 1;
            if (this.inHorizontalLine(ht[0], left) && !this.shotBefore(left) && !(ht[0] - left > shipLen - bodyLen))
                r.push(left);
            if (this.inHorizontalLine(ht[1], right) && !this.shotBefore(right) && !(right - ht[1] > shipLen - bodyLen))
                r.push(right);
            return r;
        };
        ComputerShotClass.prototype.vertGaps = function (nb) {
            var ans = [];
            var tmp = nb.map(function (x) { return x.hitVal; }).sort(function (a, b) { return a < b ? -1 : a > b ? 1 : 0; });
            for (var i = 1; i < tmp.length; i++) {
                for (var j = this._oppShips.gridSize; j < tmp[i] - tmp[i - 1]; j = j + this._oppShips.gridSize) { //that means in between those two are the gap(s)
                    ans.push(tmp[i - 1] + j);
                }
            }
            return ans;
        };
        ComputerShotClass.prototype.vertPadding = function (nb, shipLen) {
            //recommend one up(-gridSize) or one down(+gridSize) or both
            var ans = [];
            var ht = nb.map(function (s) { return s.hitVal; }).sort(function (a, b) { return a < b ? -1 : a > b ? 1 : 0; });
            ht = [ht[0], ht[ht.length - 1]];
            var bodyLen = (ht[1] - ht[0]) / this._oppShips.gridSize;
            var down = ht[1] + this._oppShips.gridSize;
            var up = ht[0] - this._oppShips.gridSize;
            if (up > 0 && !_super.prototype.shotBefore.call(this, up) && !(ht[0] - up > (shipLen - bodyLen) * this._oppShips.gridSize))
                ans.push(up);
            if (down <= this._oppShips.gridSize * this._oppShips.gridSize && !_super.prototype.shotBefore.call(this, down) && !(down - ht[1] >= (shipLen - bodyLen) * this._oppShips.gridSize))
                ans.push(down);
            return ans;
        };
        ComputerShotClass.prototype.updateNextTryMultiple = function (shipLen, x) {
            this._nextTry[shipLen].push({ hitVal: x, possible: [] });
            if (this._nextTry[shipLen].length === shipLen)
                return;
            var nb = this._nextTry[shipLen][this._nextTry[shipLen].length - 1];
            if (this.inHorizontalLine(this._nextTry[shipLen][0].hitVal, this._nextTry[shipLen][1].hitVal)) {
                var horiGaps = this.horiGaps(this._nextTry[shipLen]);
                if (horiGaps.length > 0) {
                    nb.possible = horiGaps;
                    return;
                }
                nb.possible = this.horiPadding(this._nextTry[shipLen], shipLen);
            }
            else {
                var vg = this.vertGaps(this._nextTry[shipLen]);
                if (vg.length > 0) {
                    nb.possible = vg;
                    return;
                }
                nb.possible = this.vertPadding(this._nextTry[shipLen], shipLen);
            }
        };
        ComputerShotClass.prototype.updateNextTry = function (shipLen, x) {
            this.addToShipProcessing(shipLen);
            if (this._nextTry[shipLen].length > 0)
                this.updateNextTryMultiple(shipLen, x); //that means it got hit before perhaps accidently the last time
            else {
                var hori = this.calculateHori(shipLen, x);
                var vert = this.calculateVert(shipLen, x);
                if (hori.length > 0)
                    this._nextTry[shipLen].push({ hitVal: x, possible: hori });
                else
                    this._nextTry[shipLen].push({ hitVal: x, possible: vert });
            }
        };
        ComputerShotClass.prototype.updateSingle = function (shipLen, x, nb) {
            //no need to put new next best just need to update the current nextbest
            var hori = this.calculateHori(shipLen, x);
            var vert = this.calculateVert(shipLen, x);
            if (hori.length > 0)
                nb.possible = hori;
            else
                nb.possible = vert;
        };
        ComputerShotClass.prototype.calculateVert = function (shipLen, x) {
            // check if vertically is posible
            var upAns = [];
            var downAns = [];
            var upT = x - this._oppShips.gridSize;
            var downT = x + this._oppShips.gridSize;
            while (upT >= 1 && !this.shotBefore(upT) && ((x - upT) / this._oppShips.gridSize) + 1 <= shipLen) {
                upAns.push(upT);
                upT = upT - this._oppShips.gridSize;
            }
            while (downT <= this._oppShips.gridSize * this._oppShips.gridSize && !this.shotBefore(downT) && ((downT - x) / this._oppShips.gridSize) + 1 <= shipLen) {
                downAns.push(downT);
                downT = downT + this._oppShips.gridSize;
            }
            var ans = upAns.concat(downAns);
            if (ans.length + 1 < shipLen)
                return []; //not viable
            else {
                if (ans.length < 2)
                    return ans;
                else {
                    if (upAns.length > 0 && downAns.length > 0)
                        return [upAns[0], downAns[0]];
                    else if (upAns.length > 0)
                        return [upAns[0]];
                    else
                        return [downAns[0]];
                }
            }
        };
        ComputerShotClass.prototype.calculateHori = function (shipLen, x) {
            //check how far it can go up
            // check if vertically is posible
            var leftAns = [];
            var rightAns = [];
            var leftT = x - 1;
            var rightT = x + 1;
            while (leftT >= 1 && this.inHorizontalLine(leftT, x) && !this.shotBefore(leftT) && (x - leftT + 1 <= shipLen)) {
                leftAns.push(leftT);
                leftT = leftT - 1;
            }
            while (rightT <= this._oppShips.gridSize * this._oppShips.gridSize && this.inHorizontalLine(rightT, x) && !this.shotBefore(rightT) && (rightT - x + 1 <= shipLen)) {
                rightAns.push(rightT);
                rightT = rightT + 1;
            }
            var ans = rightAns.concat(leftAns);
            if (ans.length + 1 < shipLen)
                return []; //not viable
            else {
                if (ans.length < 2)
                    return ans;
                else {
                    if (leftAns.length > 0 && rightAns.length > 0)
                        return [leftAns[0], rightAns[0]];
                    else if (leftAns.length > 0)
                        return [leftAns[0]];
                    else
                        return [rightAns[0]];
                }
            }
        };
        ComputerShotClass.prototype.inHorizontalLine = function (curr, n) {
            if (curr % this._oppShips.gridSize === 0)
                curr--;
            return Math.floor(curr / this._oppShips.gridSize) * this._oppShips.gridSize + 1 <= n && Math.floor(curr / this._oppShips.gridSize) * this._oppShips.gridSize + this._oppShips.gridSize >= n;
        };
        return ComputerShotClass;
    }(ShotClass));

    var initVal$ = function (gridSize, shipsNo, iterations) { return rxjs.of({})
        .pipe(operators.map(function (_) {
        var cc = new ComputerClass({ ships: [], allPos: new Map() }, gridSize, shipsNo);
        return {
            "gridSize": gridSize,
            "shipsNo": shipsNo,
            board: cc,
            playerShot: new PlayerShotClass(cc),
            computerShot: new ComputerShotClass(cc)
        };
    })); };
    var computerSetup$ = function (sci, gridSize, ships) { return rxjs.interval().pipe(operators.map(function (_) { return Math.floor(Math.random() * (gridSize * gridSize)) + 1; }), operators.scan(function (acc, curr) { return acc.add(curr); }, sci), operators.takeWhile(function (x) { return x.shipman.ships.length < ships; })); };
    var ɵ0 = computerSetup$;
    var setUp$ = function (initial) { return computerSetup$(initial.board, initial.gridSize, initial.shipsNo); };

    //initialize the pScore and cSccore()
    //the shots$ will return [total computer shots, total player shots]
    var shots$ = function (b) {
        function initScore() {
            var r = {};
            for (var i = 0; i < b.shipsNo; i++) {
                r[i + 1] = i + 1;
            }
            return r;
        }
        var pScore = new rxjs.BehaviorSubject(initScore());
        var cScore = new rxjs.BehaviorSubject(initScore());
        var oppBoard$ = rxjs.of(b.board.shipman.ships);
        var computerShot$ = function (c) { return rxjs.interval().pipe(operators.takeWhile(function (_) { return !(Object.values(cScore.value).filter(function (x) { return x !== 0; }).length === 0); }), operators.scan(function (acc, curr) { return ++acc; }, 0), operators.tap(function (_) { return c.shoot(0, cScore); }), operators.map(function (x) {
            return { turns: x, shots: c.shots };
        })); };
        var playerShot$ = function (p) { return rxjs.interval().pipe(operators.takeWhile(function (_) { return !(Object.values(pScore.value).filter(function (x) { return x !== 0; }).length === 0); }), operators.scan(function (acc) { return ++acc; }, 0), operators.tap(function (_) { return p.shoot(0, pScore); }), operators.map(function (x) {
            return { turns: x, shots: p.shots };
        })); };
        return rxjs.forkJoin({ oppBoard: oppBoard$, computerStatus: computerShot$(b.computerShot), playerStatus: playerShot$(b.playerShot) });
    };

    /*
    map(_=>{
      if(Number.isNaN(shipsNo) || Number.isNaN(gridSize) || Number.isNaN(iterations))  throw new Battleship_performanceError("All parameters must not be NaN");
      if(shipsNo <=0 || gridSize <=0 || iterations <= 0)  throw new Battleship_performanceError("All parameters must be above 0");
      if(gridSize < shipsNo) throw new Battleship_performanceError("gridSize cannot be less than shipsNo");
      return;
    }),
    catchError((err:Battleship_performanceError)=> {
      return throwError(err)
    })
    */
    var checkNan = function (n) { return "" + n === "undefined"; };
    var ɵ0$1 = checkNan;
    var game$ = function (gridSize, shipsNo, iterations) { return rxjs.of({}).pipe(operators.tap(function (_) {
        if (checkNan(shipsNo) || checkNan(gridSize) || checkNan(iterations))
            throw new Battleship_performanceError("All parameters must be filled");
        if (shipsNo <= 0 || gridSize <= 0 || iterations <= 0)
            throw new Battleship_performanceError("All parameters must be above 0");
        if (gridSize < shipsNo)
            throw new Battleship_performanceError("gridSize cannot be less than shipsNo");
    }), operators.catchError(function (err) {
        return rxjs.throwError(err);
    }), operators.concatMap(function (_) { return initVal$(gridSize, shipsNo, iterations).pipe(operators.switchMap(function (initial) { return rxjs.concat(setUp$(initial), shots$(initial)); }), operators.last(), operators.scan(function (acc, curr) {
        acc.games++;
        acc.computerStatus = curr.computerStatus;
        acc.playerStatus = curr.playerStatus;
        acc.oppBoard = curr.oppBoard;
        return acc;
    }, { games: 0, computerStatus: { turns: 0, shots: [] }, playerStatus: { turns: 0, shots: [] }, oppBoard: [] }), operators.repeat(iterations)); })); };

    var BattleshipPerformanceService = /** @class */ (function () {
        function BattleshipPerformanceService() {
        }
        BattleshipPerformanceService.prototype.game = function (gridSize, shipsNo, iterations) {
            return game$(gridSize, shipsNo, iterations);
        };
        return BattleshipPerformanceService;
    }());
    BattleshipPerformanceService.ɵprov = i0.ɵɵdefineInjectable({ factory: function BattleshipPerformanceService_Factory() { return new BattleshipPerformanceService(); }, token: BattleshipPerformanceService, providedIn: "root" });
    BattleshipPerformanceService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    /*
     * Public API Surface of battleship-performance
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BattleshipPerformanceService = BattleshipPerformanceService;
    exports.Battleship_performanceError = Battleship_performanceError;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=battleship-performance.umd.js.map
