import { ShotClass } from "./shotsClass";
import { BehaviorSubject } from "rxjs";
import { ShipClassInterface } from "./shipclass";
interface NextBest {
    hitVal: number;
    possible: number[];
}
interface NextTry {
    [shipLen: number]: NextBest[];
}
export declare class ComputerShotClass extends ShotClass {
    _nextTry: NextTry;
    _shipProcessing: number[];
    constructor(oppShips: ShipClassInterface);
    shoot(x: number, scoreBoard: BehaviorSubject<any>): boolean;
    private addToShipProcessing;
    private horiGaps;
    private horiPadding;
    private vertGaps;
    private vertPadding;
    private updateNextTryMultiple;
    private updateNextTry;
    private updateSingle;
    private calculateVert;
    private calculateHori;
    private inHorizontalLine;
}
export {};
