import { ShipClassInterface } from "./shipclass";
import { PlayerShotClass } from "./playerShotClass";
import { Boards } from "./interfaces";
import { ComputerShotClass } from "./computerShotClass";
export declare const initVal$: (gridSize: number, shipsNo: number, iterations: number) => import("rxjs").Observable<{
    gridSize: number;
    shipsNo: number;
    board: ShipClassInterface;
    playerShot: PlayerShotClass;
    computerShot: ComputerShotClass;
}>;
export declare const setUp$: (initial: Boards) => import("rxjs").Observable<ShipClassInterface>;
