import { ShipClassInterface } from "./shipclass";
import { BehaviorSubject } from "rxjs";
export interface Shot {
    hit: boolean;
    pos: number;
    shipLen?: number;
}
export interface ShotClassInterface {
    shots: Shot[];
    shoot(x: number, s: BehaviorSubject<any>): boolean;
}
export declare class ShotClass implements ShotClassInterface {
    _shots: Shot[];
    _oppShips: ShipClassInterface;
    _shotOpti: Map<number, number>;
    constructor(oppShips: ShipClassInterface);
    get shots(): Shot[];
    protected shotBefore(x: number): boolean;
    shoot(x: number, s: BehaviorSubject<any>): boolean;
}
